#Public Declare Function GetWindowsDirectoryA Lib "KERNEL32"
#(ByVal lpbuffer As String, ByVal nsize As Integer) As Long
load dll02
set errs {}

#nightmare stuff finding the wincrap system directory
set i [::dll::call kernel32 GetWindowsDirectoryA i {*256 windir} {i 255}]
puts "$i [string range $windir 0 $i]"

#now use the test dll
set i1 10
set i2 17

#returns an int
set i [::dll::call ./objs/testdll.dll func_i i [list i $i1] [list i $i2]]
puts "[expr {$i1+$i2}]=$i"

#returns a double
set i [::dll::call ./objs/testdll.dll func_r d [list i $i1]]
puts "[expr {$i1*1.1}]=$i"

#returns a long (same as int)
set i [::dll::call ./objs/testdll.dll func_l4 i [list i $i1]]
puts "[expr {$i1*23}]=$i"

#returns 2 longs (8 bytes)
set i [::dll::call ./objs/testdll.dll func_l8 8 [list i $i1]]
binary scan $i i2 v1
puts "length i=[string length $i]"
puts "{[expr {$i1+1}] [expr {$i1*23}]}={$v1}"

#returns double & long (12 bytes) this is the general case
#as no registers are used for the return
set i [::dll::call ./objs/testdll.dll func_l12 12 [list i $i1]]
binary scan $i di v1 v2
puts "length i=[string length $i]"
puts "{[expr {$i1*1.1}] [expr {$i1*23}]}={$v1 $v2}"

#returns length of a string passed as a constant
set i [::dll::call ./objs/testdll.dll func_i_sa i {s 0123456789}]
puts "[string length 0123456789]=$i"

##############################################
#	__stdcall
#returns an int
set i [::dll::call ./objs/testdll.dll sfunc_i i [list i $i1] [list i $i2]]
puts "[expr {$i1+$i2}]=$i"

#returns a double
set i [::dll::call ./objs/testdll.dll sfunc_r d [list i $i1]]
puts "[expr {$i1*1.1}]=$i"

#returns a long (same as int)
set i [::dll::call ./objs/testdll.dll sfunc_l4 i [list i $i1]]
puts "[expr {$i1*23}]=$i"

#returns 2 longs (8 bytes)
set i [::dll::call ./objs/testdll.dll sfunc_l8 8 [list i $i1]]
binary scan $i i2 v1
puts "length i=[string length $i]"
puts "{[expr {$i1+1}] [expr {$i1*23}]}={$v1}"

#returns double & long (12 bytes) this is the general case
#as no registers are used for the return
set i [::dll::call ./objs/testdll.dll sfunc_l12 12 [list i $i1]]
binary scan $i di v1 v2
puts "length i=[string length $i]"
puts "{[expr {$i1*1.1}] [expr {$i1*23}]}={$v1 $v2}"

#returns length of a string passed as a constant
set i [::dll::call ./objs/testdll.dll sfunc_i_sa i {s 0123456789}]
puts "[string length 0123456789]=$i"

set chord [file join $windir media chord.wav]
if {[file exists $chord]} {
	::dll::call winmm PlaySound i [list s $chord] {i 0} {i 0}
	} \
else {
	append errs "Can't play chord.wav\n"
	}

if {"$errs"!=""} {
	error "$errs"
	}
