#ifndef	_GENCB_H
#define _GENCB_H
#ifndef	__WIN32__
#	define __cdecl
#	define __stdcall
#endif
#ifdef	__cplusplus
extern	"C"{
#endif
#include <setjmp.h>
typedef	struct	{
				char	argtype;
				size_t	arglen;
				} CBA_t, *pCBA_t;
typedef	struct {
			void*		mem;
			size_t		memlen;
			size_t		mempos;
			} DynBytes_t, *pDynBytes_t;

typedef	struct	{
				size_t	nargs;
				size_t	targlen;
				CBA_t	argdef[1];
				} CBAD_t, *pCBAD_t;

typedef struct	{
				int used;
				jmp_buf escape;
				} CB_Escape_t, *pCB_Escape_t;

typedef	struct	CBD_t {
				Tcl_Interp*		cb_interp;
				char*			cb_name;
				char*			cb_tcl_proc_name;
				pCBAD_t			cb_argdef;
				char*			cb_code;
				pCB_Escape_t	cb_escape;
				struct CBD_t	*next;
				unsigned		cb_stdcall:1;
				} CBD_t, *pCBD_t;

void	DynBytes_Align(pDynBytes_t);
void	DynBytes_Extend(pDynBytes_t,size_t);
void	DynBytes_Append(pDynBytes_t,size_t,void*);
void	DynBytes_Init(pDynBytes_t);
void	DynBytes_Finish(pDynBytes_t);
char*	Generate_Callback(pCBD_t, void*);
char*	Generate_Argdef(pCBA_t, char*);
#ifdef	__cplusplus
extern	}
#endif
#endif
