#include <string.h>
#ifndef	__WIN32__
#	define __cdecl
#	define __stdcall
#else
#	include <windows.h>
#endif
typedef	struct {
				double 	a;
				int		b;
				} rec12;
typedef	struct {
				long	a;
				long	b;
				} rec4;
static	int record;
static	char*	slevel0 = "This is level0 string";
static	int		ilevel0 = 12345678;
static	double	dlevel0 = 87.654321;
static	float	flevel0 = 7654321.0f;
static	char	nlevel0[7] = {'a','b','c','d','e','f','g'}; 
typedef	struct	{
		char*	slevel0;	/*offset 0*/
		int		ilevel0;	/*offset 4*/
		double	dlevel0;	/*offset 8*/
		float	flevel0;	/*offset 16*/
		char	nlevel0[7];	/*offset 20*/
		char**	slevel1;	/*offset 28*/
		int*	ilevel1;	/*offset 32*/
		double*	dlevel1;	/*offset 36*/
		float*	flevel1;	/*offset 40*/
		char*	nlevel1[7];	/*offset 44*/
		} level0_t;
typedef struct {
			level0_t*	level1_0;	/*offset 0*/
			level0_t*	level1_4;	/*offset 4*/
			} level1_t;
static level0_t level0 = {"this is level0 string",87654321,123456.78,1234567.0f,{'g','f','e','d','c','b','a'},
						&slevel0,&ilevel0,&dlevel0,&flevel0,nlevel0};
static level1_t level1 = {&level0,&level0};

static int	infunc_0(int i)
{
	return i*2;
}

static int	infunc_1(int i)
{
	return i*3+1;
}

static int	infunc_2(int i)
{
	return i*4+2;
}

typedef	int (*indirect_fcn_t)(int);
static	indirect_fcn_t	indvec[]={infunc_0,infunc_1,infunc_2};

void	func_v(int i, int j, int k)
{
	record = (i*10+j)*10+k;
}
int	getrecord(void)
{
	return record;
}
void	setrecord(int i)
{
	record = i;
}
void*	dll_getaddress(int i)
{
	switch(i){
		case 0: return (void*)&level0;
		case 1: return (void*)&level1;
		case 2: return (void*)&(indvec[0]);
		case 3: return (void*)setrecord;
		case 4: return (void*)getrecord;
		}
	return NULL;
}
int	func_i(int i, int j)
{
	return i*10+j;
}
double func_r(int i)
{
	return (double)i*1.1;
}
long	func_l4(int i)
{
	return i*23;
}
rec4	func_l8(int i)
{
	rec4 r;
	r.a =1+i;
	r.b = 23*i;
	return r;
}
rec12	func_l12(int i)
{
	rec12 r;
	r.a = 1.1*i;
	r.b = 23*i;
	return r;
}
int	func_i_sa(const char* s)
{
	return strlen(s);
}

void	func_v_ia(char* s)
{
	strcpy(s,"1234567");
}

void __stdcall	sfunc_v(int i, int j, int k)
{
	record = (i*10+j)*10+k;
}
int __stdcall sfunc_i(int i, int j)
{
	return i*10+j;
}
double __stdcall sfunc_r(int i)
{
	return (double)i*1.1;
}
long __stdcall sfunc_l4(int i)
{
	return i*23;
}
rec4 __stdcall sfunc_l8(int i)
{
	rec4 r;
	r.a =1+i;
	r.b = 23*i;
	return r;
}
rec12 __stdcall sfunc_l12(int i)
{
	rec12 r;
	r.a = 1.1*i;
	r.b = 23*i;
	return r;
}
int __stdcall sfunc_i_sa(const char* s)
{
	return strlen(s);
}

typedef	struct {char a[277];}big277;

typedef	int		(*cCBf1)(int,char*);
typedef	int	(*__stdcall sCBf1)(int,char*);
int	UseA_cdecl_CB1(int i,char* s,cCBf1 p)
{
	return p(i,s);
}
int	UseA_stdcall_CB1(int i,char* s,sCBf1 p)
{
	return p(i,s);
}

typedef	void (*cCBf2)(big277);
void	UseA_cdecl_CB2(int i,cCBf2 p)
{
	big277	a;
	int		j;
	for(j=0;j<20;j++) a.a[j] = 'a';
	for(;j<250;j++) a.a[j] = i;
	for(;j<277;j++) a.a[j] = 'b';
	p(a);
}

typedef	double (*cCBf3)(int,double);
double	UseA_cdecl_CB3(double f,int i, cCBf3 p)
{
	return 2*p(i,f)+i;
}

int	testGetUserName( char *name, size_t* len )
{
	strncpy(name,"bingo",*len);
	*len = strlen(name);
	return 1;
}

int IntPtr( int *ptr )
{
	*ptr = 0x12345678;
	return *ptr;
}

#ifdef __WIN32__
/* special test for David Karpa */
short WINAPI rtx_StartTxLabel(short channel, unsigned long period, long data, short tx_control)
{
	switch(record){
		case 0:
			return channel;
		case 1:
			return (short)(period&0xffff);
		case 2:
			return (short)((period>>16)&0xffff);
		case 3:
			return data&0xffff;
		case 4:
			return (data>>16)&0xffff;
		case 5:
			return tx_control;
		default:
			return (short)0xffff;
		}
}
#endif
