#	sets TCP_NODELAY flag for
#	socket		sock
#	direction	d either w or r
proc SetNodelay {sock d v} {
	switch $d {
		w	{set d 4}
		r	{set d 2}
		default {error "SetNodelay: bad direction"}
		}
	set C [::dll::call tcl80 Tcl_GetChannel i \
		[list i [::dll::get_interp]] [list s $sock] {i 0}]
	if {[::dll::call tcl80 Tcl_GetChannelHandle i \
		[list i $C] [list i $d] {*4 H}]} {
		error "SetNodelay: can't get handle"
		}
	binary scan $H i HV

	if {$v} {
		set v "\1\0\0\0"
		} \
	else {
		set v "\0\0\0\0"
		}
	return [::dll::call wsock32 setsockopt i \
		[list i $HV] \
		{i 6} {i 1} {*4 v} {i 4}]
	}
